/**
 * EasyQRCodeJS-NodeJS
 *
 * NodeJS QRCode generator. Save image to file. Support Dot style, Logo, Background image, Colorful, Title, etc.(Running without DOM on server side)
 *
 * Version 3.5.2
 *
 * @author [ inthinkcolor@gmail.com ]
 *
 * @see https://github.com/ushelp/EasyQRCodeJS-NodeJS
 * @see http://www.easyproject.cn/easyqrcodejs/tryit.html
 * @see https://github.com/ushelp/EasyQRCodeJS
 *
 * Copyright 2017 Ray, EasyProject
 * Released under the MIT license
 *
 * [Node.js]
 *
 */
var{createCanvas,loadImage,Image}=require("canvas"),fs=require("fs");function QR8bitByte(a){this.mode=QRMode.MODE_8BIT_BYTE,this.data=a,this.parsedData=[];for(var b=0,c=this.data.length;b<c;b++){var d=[],e=this.data.charCodeAt(b);65536<e?(d[0]=240|(1835008&e)>>>18,d[1]=128|(258048&e)>>>12,d[2]=128|(4032&e)>>>6,d[3]=128|63&e):2048<e?(d[0]=224|(61440&e)>>>12,d[1]=128|(4032&e)>>>6,d[2]=128|63&e):128<e?(d[0]=192|(1984&e)>>>6,d[1]=128|63&e):d[0]=e,this.parsedData.push(d)}this.parsedData=Array.prototype.concat.apply([],this.parsedData),this.parsedData.length!=this.data.length&&(this.parsedData.unshift(191),this.parsedData.unshift(187),this.parsedData.unshift(239))}QR8bitByte.prototype={getLength:function(){return this.parsedData.length},write:function(a){for(var b=0,c=this.parsedData.length;b<c;b++)a.put(this.parsedData[b],8)}};function QRCodeModel(a,b){this.typeNumber=a,this.errorCorrectLevel=b,this.modules=null,this.moduleCount=0,this.dataCache=null,this.dataList=[]}QRCodeModel.prototype={addData:function(a){var b=new QR8bitByte(a);this.dataList.push(b),this.dataCache=null},isDark:function(a,b){if(0>a||this.moduleCount<=a||0>b||this.moduleCount<=b)throw new Error(a+","+b);return this.modules[a][b][0]},getEye:function(a,b){if(0>a||this.moduleCount<=a||0>b||this.moduleCount<=b)throw new Error(a+","+b);var c=this.modules[a][b];if(c[1]){var d="P"+c[1]+"_"+c[2];return"A"==c[2]&&(d="A"+c[1]),{isDarkBlock:c[0],type:d}}return null},getModuleCount:function(){return this.moduleCount},make:function(){this.makeImpl(!1,this.getBestMaskPattern())},makeImpl:function(a,b){this.moduleCount=4*this.typeNumber+17,this.modules=Array(this.moduleCount);for(var c=0;c<this.moduleCount;c++){this.modules[c]=Array(this.moduleCount);for(var d=0;d<this.moduleCount;d++)this.modules[c][d]=[]}this.setupPositionProbePattern(0,0,"TL"),this.setupPositionProbePattern(this.moduleCount-7,0,"BL"),this.setupPositionProbePattern(0,this.moduleCount-7,"TR"),this.setupPositionAdjustPattern("A"),this.setupTimingPattern(),this.setupTypeInfo(a,b),7<=this.typeNumber&&this.setupTypeNumber(a),null==this.dataCache&&(this.dataCache=QRCodeModel.createData(this.typeNumber,this.errorCorrectLevel,this.dataList)),this.mapData(this.dataCache,b)},setupPositionProbePattern:function(a,b,d){for(var e=-1;7>=e;e++)if(!(-1>=a+e||this.moduleCount<=a+e))for(var f=-1;7>=f;f++)-1>=b+f||this.moduleCount<=b+f||(0<=e&&6>=e&&(0==f||6==f)||0<=f&&6>=f&&(0==e||6==e)||2<=e&&4>=e&&2<=f&&4>=f?(this.modules[a+e][b+f][0]=!0,this.modules[a+e][b+f][2]=d,this.modules[a+e][b+f][1]=-0==e||-0==f||6==e||6==f?"O":"I"):this.modules[a+e][b+f][0]=!1)},getBestMaskPattern:function(){for(var a=0,b=0,c=0;8>c;c++){this.makeImpl(!0,c);var d=QRUtil.getLostPoint(this);(0==c||a>d)&&(a=d,b=c)}return b},createMovieClip:function(a,b,c){var d=a.createEmptyMovieClip(b,c),e=1;this.make();for(var f,g=0;g<this.modules.length;g++){f=g*e;for(var h=0;h<this.modules[g].length;h++){var i=h*e,j=this.modules[g][h][0];j&&(d.beginFill(0,100),d.moveTo(i,f),d.lineTo(i+e,f),d.lineTo(i+e,f+e),d.lineTo(i,f+e),d.endFill())}}return d},setupTimingPattern:function(){for(var a=8;a<this.moduleCount-8;a++)null==this.modules[a][6][0]&&(this.modules[a][6][0]=0==a%2);for(var b=8;b<this.moduleCount-8;b++)null==this.modules[6][b][0]&&(this.modules[6][b][0]=0==b%2)},setupPositionAdjustPattern:function(a){for(var b=QRUtil.getPatternPosition(this.typeNumber),d=0;d<b.length;d++)for(var e=0;e<b.length;e++){var f=b[d],g=b[e];if(null==this.modules[f][g][0])for(var h=-2;2>=h;h++)for(var k=-2;2>=k;k++)-2==h||2==h||-2==k||2==k||0==h&&0==k?(this.modules[f+h][g+k][0]=!0,this.modules[f+h][g+k][2]=a,this.modules[f+h][g+k][1]=-2==h||-2==k||2==h||2==k?"O":"I"):this.modules[f+h][g+k][0]=!1}},setupTypeNumber:function(a){for(var b,c=Math.floor,d=QRUtil.getBCHTypeNumber(this.typeNumber),e=0;18>e;e++)b=!a&&1==(1&d>>e),this.modules[c(e/3)][e%3+this.moduleCount-8-3][0]=b;for(var b,e=0;18>e;e++)b=!a&&1==(1&d>>e),this.modules[e%3+this.moduleCount-8-3][c(e/3)][0]=b},setupTypeInfo:function(a,b){for(var c,d=this.errorCorrectLevel<<3|b,e=QRUtil.getBCHTypeInfo(d),f=0;15>f;f++)c=!a&&1==(1&e>>f),6>f?this.modules[f][8][0]=c:8>f?this.modules[f+1][8][0]=c:this.modules[this.moduleCount-15+f][8][0]=c;for(var c,f=0;15>f;f++)c=!a&&1==(1&e>>f),8>f?this.modules[8][this.moduleCount-f-1][0]=c:9>f?this.modules[8][15-f-1+1][0]=c:this.modules[8][15-f-1][0]=c;this.modules[this.moduleCount-8][8][0]=!a},mapData:function(a,b){for(var d=-1,e=this.moduleCount-1,f=7,g=0,h=this.moduleCount-1;0<h;h-=2)for(6==h&&h--;;){for(var i=0;2>i;i++)if(null==this.modules[e][h-i][0]){var j=!1;g<a.length&&(j=1==(1&a[g]>>>f));var k=QRUtil.getMask(b,e,h-i);k&&(j=!j),this.modules[e][h-i][0]=j,f--,-1==f&&(g++,f=7)}if(e+=d,0>e||this.moduleCount<=e){e-=d,d=-d;break}}}},QRCodeModel.PAD0=236,QRCodeModel.PAD1=17,QRCodeModel.createData=function(a,b,c){for(var d,e=QRRSBlock.getRSBlocks(a,b),f=new QRBitBuffer,g=0;g<c.length;g++)d=c[g],f.put(d.mode,4),f.put(d.getLength(),QRUtil.getLengthInBits(d.mode,a)),d.write(f);for(var h=0,g=0;g<e.length;g++)h+=e[g].dataCount;if(f.getLengthInBits()>8*h)throw new Error("code length overflow. ("+f.getLengthInBits()+">"+8*h+")");for(f.getLengthInBits()+4<=8*h&&f.put(0,4);0!=f.getLengthInBits()%8;)f.putBit(!1);for(;!(f.getLengthInBits()>=8*h)&&!(f.put(QRCodeModel.PAD0,8),f.getLengthInBits()>=8*h);)f.put(QRCodeModel.PAD1,8);return QRCodeModel.createBytes(f,e)},QRCodeModel.createBytes=function(a,b){for(var c=Math.max,d=0,e=0,f=0,g=Array(b.length),h=Array(b.length),j=0;j<b.length;j++){var k=b[j].dataCount,l=b[j].totalCount-k;e=c(e,k),f=c(f,l),g[j]=Array(k);for(var m=0;m<g[j].length;m++)g[j][m]=255&a.buffer[m+d];d+=k;var n=QRUtil.getErrorCorrectPolynomial(l),o=new QRPolynomial(g[j],n.getLength()-1),p=o.mod(n);h[j]=Array(n.getLength()-1);for(var q,m=0;m<h[j].length;m++)q=m+p.getLength()-h[j].length,h[j][m]=0<=q?p.get(q):0}for(var s=0,m=0;m<b.length;m++)s+=b[m].totalCount;for(var t=Array(s),u=0,m=0;m<e;m++)for(var j=0;j<b.length;j++)m<g[j].length&&(t[u++]=g[j][m]);for(var m=0;m<f;m++)for(var j=0;j<b.length;j++)m<h[j].length&&(t[u++]=h[j][m]);return t};for(var QRMode={MODE_NUMBER:1,MODE_ALPHA_NUM:2,MODE_8BIT_BYTE:4,MODE_KANJI:8},QRErrorCorrectLevel={L:1,M:0,Q:3,H:2},QRMaskPattern={PATTERN000:0,PATTERN001:1,PATTERN010:2,PATTERN011:3,PATTERN100:4,PATTERN101:5,PATTERN110:6,PATTERN111:7},QRUtil={PATTERN_POSITION_TABLE:[[],[6,18],[6,22],[6,26],[6,30],[6,34],[6,22,38],[6,24,42],[6,26,46],[6,28,50],[6,30,54],[6,32,58],[6,34,62],[6,26,46,66],[6,26,48,70],[6,26,50,74],[6,30,54,78],[6,30,56,82],[6,30,58,86],[6,34,62,90],[6,28,50,72,94],[6,26,50,74,98],[6,30,54,78,102],[6,28,54,80,106],[6,32,58,84,110],[6,30,58,86,114],[6,34,62,90,118],[6,26,50,74,98,122],[6,30,54,78,102,126],[6,26,52,78,104,130],[6,30,56,82,108,134],[6,34,60,86,112,138],[6,30,58,86,114,142],[6,34,62,90,118,146],[6,30,54,78,102,126,150],[6,24,50,76,102,128,154],[6,28,54,80,106,132,158],[6,32,58,84,110,136,162],[6,26,54,82,110,138,166],[6,30,58,86,114,142,170]],G15:1335,G18:7973,G15_MASK:21522,getBCHTypeInfo:function(a){for(var b=a<<10;0<=QRUtil.getBCHDigit(b)-QRUtil.getBCHDigit(QRUtil.G15);)b^=QRUtil.G15<<QRUtil.getBCHDigit(b)-QRUtil.getBCHDigit(QRUtil.G15);return(a<<10|b)^QRUtil.G15_MASK},getBCHTypeNumber:function(a){for(var b=a<<12;0<=QRUtil.getBCHDigit(b)-QRUtil.getBCHDigit(QRUtil.G18);)b^=QRUtil.G18<<QRUtil.getBCHDigit(b)-QRUtil.getBCHDigit(QRUtil.G18);return a<<12|b},getBCHDigit:function(a){for(var b=0;0!=a;)b++,a>>>=1;return b},getPatternPosition:function(a){return QRUtil.PATTERN_POSITION_TABLE[a-1]},getMask:function(a,b,c){var d=Math.floor;switch(a){case QRMaskPattern.PATTERN000:return 0==(b+c)%2;case QRMaskPattern.PATTERN001:return 0==b%2;case QRMaskPattern.PATTERN010:return 0==c%3;case QRMaskPattern.PATTERN011:return 0==(b+c)%3;case QRMaskPattern.PATTERN100:return 0==(d(b/2)+d(c/3))%2;case QRMaskPattern.PATTERN101:return 0==b*c%2+b*c%3;case QRMaskPattern.PATTERN110:return 0==(b*c%2+b*c%3)%2;case QRMaskPattern.PATTERN111:return 0==(b*c%3+(b+c)%2)%2;default:throw new Error("bad maskPattern:"+a);}},getErrorCorrectPolynomial:function(b){for(var c=new QRPolynomial([1],0),d=0;d<b;d++)c=c.multiply(new QRPolynomial([1,QRMath.gexp(d)],0));return c},getLengthInBits:function(a,b){if(1<=b&&10>b)switch(a){case QRMode.MODE_NUMBER:return 10;case QRMode.MODE_ALPHA_NUM:return 9;case QRMode.MODE_8BIT_BYTE:return 8;case QRMode.MODE_KANJI:return 8;default:throw new Error("mode:"+a);}else if(27>b)switch(a){case QRMode.MODE_NUMBER:return 12;case QRMode.MODE_ALPHA_NUM:return 11;case QRMode.MODE_8BIT_BYTE:return 16;case QRMode.MODE_KANJI:return 10;default:throw new Error("mode:"+a);}else if(41>b)switch(a){case QRMode.MODE_NUMBER:return 14;case QRMode.MODE_ALPHA_NUM:return 13;case QRMode.MODE_8BIT_BYTE:return 16;case QRMode.MODE_KANJI:return 12;default:throw new Error("mode:"+a);}else throw new Error("type:"+b)},getLostPoint:function(a){for(var b=a.getModuleCount(),d=0,e=0;e<b;e++)for(var f=0;f<b;f++){for(var g=0,h=a.isDark(e,f),i=-1;1>=i;i++)if(!(0>e+i||b<=e+i))for(var j=-1;1>=j;j++)0>f+j||b<=f+j||(0!=i||0!=j)&&h==a.isDark(e+i,f+j)&&g++;5<g&&(d+=3+g-5)}for(var e=0;e<b-1;e++)for(var k,f=0;f<b-1;f++)k=0,a.isDark(e,f)&&k++,a.isDark(e+1,f)&&k++,a.isDark(e,f+1)&&k++,a.isDark(e+1,f+1)&&k++,(0==k||4==k)&&(d+=3);for(var e=0;e<b;e++)for(var f=0;f<b-6;f++)a.isDark(e,f)&&!a.isDark(e,f+1)&&a.isDark(e,f+2)&&a.isDark(e,f+3)&&a.isDark(e,f+4)&&!a.isDark(e,f+5)&&a.isDark(e,f+6)&&(d+=40);for(var f=0;f<b;f++)for(var e=0;e<b-6;e++)a.isDark(e,f)&&!a.isDark(e+1,f)&&a.isDark(e+2,f)&&a.isDark(e+3,f)&&a.isDark(e+4,f)&&!a.isDark(e+5,f)&&a.isDark(e+6,f)&&(d+=40);for(var l=0,f=0;f<b;f++)for(var e=0;e<b;e++)a.isDark(e,f)&&l++;var m=Math.abs(100*l/b/b-50)/5;return d+=10*m,d}},QRMath={glog:function(a){if(1>a)throw new Error("glog("+a+")");return QRMath.LOG_TABLE[a]},gexp:function(a){for(;0>a;)a+=255;for(;256<=a;)a-=255;return QRMath.EXP_TABLE[a]},EXP_TABLE:Array(256),LOG_TABLE:Array(256)},i=0;8>i;i++)QRMath.EXP_TABLE[i]=1<<i;for(var i=8;256>i;i++)QRMath.EXP_TABLE[i]=QRMath.EXP_TABLE[i-4]^QRMath.EXP_TABLE[i-5]^QRMath.EXP_TABLE[i-6]^QRMath.EXP_TABLE[i-8];for(var i=0;255>i;i++)QRMath.LOG_TABLE[QRMath.EXP_TABLE[i]]=i;function QRPolynomial(a,b){if(a.length==null)throw new Error(a.length+"/"+b);for(var c=0;c<a.length&&0==a[c];)c++;this.num=Array(a.length-c+b);for(var d=0;d<a.length-c;d++)this.num[d]=a[d+c]}QRPolynomial.prototype={get:function(a){return this.num[a]},getLength:function(){return this.num.length},multiply:function(a){for(var b=Array(this.getLength()+a.getLength()-1),c=0;c<this.getLength();c++)for(var d=0;d<a.getLength();d++)b[c+d]^=QRMath.gexp(QRMath.glog(this.get(c))+QRMath.glog(a.get(d)));return new QRPolynomial(b,0)},mod:function(a){if(0>this.getLength()-a.getLength())return this;for(var b=QRMath.glog(this.get(0))-QRMath.glog(a.get(0)),c=Array(this.getLength()),d=0;d<this.getLength();d++)c[d]=this.get(d);for(var d=0;d<a.getLength();d++)c[d]^=QRMath.gexp(QRMath.glog(a.get(d))+b);return new QRPolynomial(c,0).mod(a)}};function QRRSBlock(a,b){this.totalCount=a,this.dataCount=b}QRRSBlock.RS_BLOCK_TABLE=[[1,26,19],[1,26,16],[1,26,13],[1,26,9],[1,44,34],[1,44,28],[1,44,22],[1,44,16],[1,70,55],[1,70,44],[2,35,17],[2,35,13],[1,100,80],[2,50,32],[2,50,24],[4,25,9],[1,134,108],[2,67,43],[2,33,15,2,34,16],[2,33,11,2,34,12],[2,86,68],[4,43,27],[4,43,19],[4,43,15],[2,98,78],[4,49,31],[2,32,14,4,33,15],[4,39,13,1,40,14],[2,121,97],[2,60,38,2,61,39],[4,40,18,2,41,19],[4,40,14,2,41,15],[2,146,116],[3,58,36,2,59,37],[4,36,16,4,37,17],[4,36,12,4,37,13],[2,86,68,2,87,69],[4,69,43,1,70,44],[6,43,19,2,44,20],[6,43,15,2,44,16],[4,101,81],[1,80,50,4,81,51],[4,50,22,4,51,23],[3,36,12,8,37,13],[2,116,92,2,117,93],[6,58,36,2,59,37],[4,46,20,6,47,21],[7,42,14,4,43,15],[4,133,107],[8,59,37,1,60,38],[8,44,20,4,45,21],[12,33,11,4,34,12],[3,145,115,1,146,116],[4,64,40,5,65,41],[11,36,16,5,37,17],[11,36,12,5,37,13],[5,109,87,1,110,88],[5,65,41,5,66,42],[5,54,24,7,55,25],[11,36,12],[5,122,98,1,123,99],[7,73,45,3,74,46],[15,43,19,2,44,20],[3,45,15,13,46,16],[1,135,107,5,136,108],[10,74,46,1,75,47],[1,50,22,15,51,23],[2,42,14,17,43,15],[5,150,120,1,151,121],[9,69,43,4,70,44],[17,50,22,1,51,23],[2,42,14,19,43,15],[3,141,113,4,142,114],[3,70,44,11,71,45],[17,47,21,4,48,22],[9,39,13,16,40,14],[3,135,107,5,136,108],[3,67,41,13,68,42],[15,54,24,5,55,25],[15,43,15,10,44,16],[4,144,116,4,145,117],[17,68,42],[17,50,22,6,51,23],[19,46,16,6,47,17],[2,139,111,7,140,112],[17,74,46],[7,54,24,16,55,25],[34,37,13],[4,151,121,5,152,122],[4,75,47,14,76,48],[11,54,24,14,55,25],[16,45,15,14,46,16],[6,147,117,4,148,118],[6,73,45,14,74,46],[11,54,24,16,55,25],[30,46,16,2,47,17],[8,132,106,4,133,107],[8,75,47,13,76,48],[7,54,24,22,55,25],[22,45,15,13,46,16],[10,142,114,2,143,115],[19,74,46,4,75,47],[28,50,22,6,51,23],[33,46,16,4,47,17],[8,152,122,4,153,123],[22,73,45,3,74,46],[8,53,23,26,54,24],[12,45,15,28,46,16],[3,147,117,10,148,118],[3,73,45,23,74,46],[4,54,24,31,55,25],[11,45,15,31,46,16],[7,146,116,7,147,117],[21,73,45,7,74,46],[1,53,23,37,54,24],[19,45,15,26,46,16],[5,145,115,10,146,116],[19,75,47,10,76,48],[15,54,24,25,55,25],[23,45,15,25,46,16],[13,145,115,3,146,116],[2,74,46,29,75,47],[42,54,24,1,55,25],[23,45,15,28,46,16],[17,145,115],[10,74,46,23,75,47],[10,54,24,35,55,25],[19,45,15,35,46,16],[17,145,115,1,146,116],[14,74,46,21,75,47],[29,54,24,19,55,25],[11,45,15,46,46,16],[13,145,115,6,146,116],[14,74,46,23,75,47],[44,54,24,7,55,25],[59,46,16,1,47,17],[12,151,121,7,152,122],[12,75,47,26,76,48],[39,54,24,14,55,25],[22,45,15,41,46,16],[6,151,121,14,152,122],[6,75,47,34,76,48],[46,54,24,10,55,25],[2,45,15,64,46,16],[17,152,122,4,153,123],[29,74,46,14,75,47],[49,54,24,10,55,25],[24,45,15,46,46,16],[4,152,122,18,153,123],[13,74,46,32,75,47],[48,54,24,14,55,25],[42,45,15,32,46,16],[20,147,117,4,148,118],[40,75,47,7,76,48],[43,54,24,22,55,25],[10,45,15,67,46,16],[19,148,118,6,149,119],[18,75,47,31,76,48],[34,54,24,34,55,25],[20,45,15,61,46,16]],QRRSBlock.getRSBlocks=function(a,b){var c=QRRSBlock.getRsBlockTable(a,b);if(c==null)throw new Error("bad rs block @ typeNumber:"+a+"/errorCorrectLevel:"+b);for(var d=c.length/3,e=[],f=0;f<d;f++)for(var g=c[3*f+0],h=c[3*f+1],k=c[3*f+2],l=0;l<g;l++)e.push(new QRRSBlock(h,k));return e},QRRSBlock.getRsBlockTable=function(a,b){return b===QRErrorCorrectLevel.L?QRRSBlock.RS_BLOCK_TABLE[4*(a-1)+0]:b===QRErrorCorrectLevel.M?QRRSBlock.RS_BLOCK_TABLE[4*(a-1)+1]:b===QRErrorCorrectLevel.Q?QRRSBlock.RS_BLOCK_TABLE[4*(a-1)+2]:b===QRErrorCorrectLevel.H?QRRSBlock.RS_BLOCK_TABLE[4*(a-1)+3]:void 0};function QRBitBuffer(){this.buffer=[],this.length=0}QRBitBuffer.prototype={get:function(a){var b=Math.floor(a/8);return 1==(1&this.buffer[b]>>>7-a%8)},put:function(a,b){for(var c=0;c<b;c++)this.putBit(1==(1&a>>>b-c-1))},getLengthInBits:function(){return this.length},putBit:function(a){var b=Math.floor(this.length/8);this.buffer.length<=b&&this.buffer.push(0),a&&(this.buffer[b]|=128>>>this.length%8),this.length++}};var QRCodeLimitLength=[[17,14,11,7],[32,26,20,14],[53,42,32,24],[78,62,46,34],[106,84,60,44],[134,106,74,58],[154,122,86,64],[192,152,108,84],[230,180,130,98],[271,213,151,119],[321,251,177,137],[367,287,203,155],[425,331,241,177],[458,362,258,194],[520,412,292,220],[586,450,322,250],[644,504,364,280],[718,560,394,310],[792,624,442,338],[858,666,482,382],[929,711,509,403],[1003,779,565,439],[1091,857,611,461],[1171,911,661,511],[1273,997,715,535],[1367,1059,751,593],[1465,1125,805,625],[1528,1190,868,658],[1628,1264,908,698],[1732,1370,982,742],[1840,1452,1030,790],[1952,1538,1112,842],[2068,1628,1168,898],[2188,1722,1228,958],[2303,1809,1283,983],[2431,1911,1351,1051],[2563,1989,1423,1093],[2699,2099,1499,1139],[2809,2213,1579,1219],[2953,2331,1663,1273]];function _getTypeNumber(a,b){for(var c,d=b.correctLevel,e=1,f=_getUTF8Length(a),g=0,h=QRCodeLimitLength.length;g<=h&&(c=0,d===QRErrorCorrectLevel.L?c=QRCodeLimitLength[g][0]:d===QRErrorCorrectLevel.M?c=QRCodeLimitLength[g][1]:d===QRErrorCorrectLevel.Q?c=QRCodeLimitLength[g][2]:d===QRErrorCorrectLevel.H?c=QRCodeLimitLength[g][3]:void 0,!(f<=c));g++)e++;if(e>QRCodeLimitLength.length)throw new Error("Too long data");return 0!=b.version&&(e<=b.version?(e=b.version,b.runVersion=e):(console.warn("QR Code version "+b.version+" too small, run version use "+e),b.runVersion=e)),e}function _getUTF8Length(a){var b=encodeURI(a).toString().replace(/\%[0-9a-fA-F]{2}/g,"a");return b.length+(b.length==a?0:3)}var Drawing=function(a){this._bIsPainted=!1,this._htOption=a,this._canvas=createCanvas(200,200),this._oContext=this._canvas.getContext("2d"),this._oContext.patternQuality="best",this._oContext.quality="best",this._oContext.textDrawingMode="path",this._oContext.antialias="gray",this._bSupportDataURI=null};Drawing.prototype.draw=function(a){function b(){e.lineWidth=0,e.fillStyle=f.quietZoneColor,e.fillRect(0,0,m._canvas.width,f.quietZone),e.fillRect(0,f.quietZone,f.quietZone,m._canvas.height-2*f.quietZone),e.fillRect(m._canvas.width-f.quietZone,f.quietZone,f.quietZone,m._canvas.height-2*f.quietZone),e.fillRect(0,m._canvas.height-f.quietZone,m._canvas.width,f.quietZone)}function c(a){for(var c=0;c<g;c++)for(var l=0;l<g;l++){var n=l*h+f.quietZone,o=c*i+f.quietZone,p=a.isDark(c,l),q=a.getEye(c,l);if(q){p=q.isDarkBlock;var r=q.type,s=f[r]||f[r.substring(0,2)]||f.colorDark;e.lineWidth=0,e.strokeStyle=p?s:f.colorLight,e.fillStyle=p?s:f.colorLight,e.fillRect(n,f.titleHeight+o,h,i)}else{e.lineWidth=0,e.strokeStyle=p?f.colorDark:f.colorLight,e.fillStyle=p?f.colorDark:f.colorLight;var t=f.dotScale;if(6==c){t=1;var u=f.timing_H||f.timing||f.colorDark;e.fillStyle=p?u:f.colorLight,e.strokeStyle=e.fillStyle,e.fillRect(n+h*(1-t)/2,f.titleHeight+o+i*(1-t)/2,h*t,i*t)}else if(6==l){t=1;var v=f.timing_V||f.timing||f.colorDark;e.fillStyle=p?v:f.colorLight,e.strokeStyle=e.fillStyle,e.fillRect(n+h*(1-t)/2,f.titleHeight+o+i*(1-t)/2,h*t,i*t)}else f.backgroundImage?(f.autoColor?(e.strokeStyle=p?j:k,e.fillStyle=p?j:k):(e.fillStyle=p?f.colorDark:f.colorLight,e.strokeStyle=e.fillStyle),e.fillRect(n+h*(1-t)/2,f.titleHeight+o+i*(1-t)/2,h*t,i*t)):(e.strokeStyle=e.fillStyle,e.fillRect(n+h*(1-t)/2,f.titleHeight+o+i*(1-t)/2,h*t,i*t))}1==f.dotScale||q||(e.strokeStyle=f.colorLight)}if(f.title&&(e.fillStyle=f.titleBackgroundColor,e.fillRect(0,0,m._canvas.width,f.titleHeight+this._htOption.quietZone),e.font=f.titleFont,e.fillStyle=f.titleColor,e.textAlign="center",e.fillText(f.title,m._canvas.width/2,this._htOption.quietZone+this._htOption.titleTop)),f.subTitle&&(e.font=f.subTitleFont,e.fillStyle=f.subTitleColor,e.fillText(f.subTitle,m._canvas.width/2,this._htOption.quietZone+this._htOption.subTitleTop)),f.logo){function a(){var a=d(f.width/3.5),c=d(f.height/3.5);a!=c&&(a=c),f.logoWidth&&(a=d(f.logoWidth)),f.logoHeight&&(c=d(f.logoHeight)),f.logoBackgroundTransparent||(e.fillStyle=f.logoBackgroundColor,e.fillRect((f.width+2*f.quietZone-a)/2,(f.height+f.titleHeight+2*f.quietZone-c)/2,a,a)),e.drawImage(w,(f.width+2*f.quietZone-a)/2,(f.height+f.titleHeight+2*f.quietZone-c)/2,a,c),x._bIsPainted=!0,0<f.quietZone&&f.quietZoneColor&&b(),x.makeImage()}var w=new Image;w.src=f.logo;var x=this;if(w.onload=function(){a()},w.onerror=function(a){console.error(a)},w.complete)return w.onload=null,void a()}else this._bIsPainted=!0,0<f.quietZone&&f.quietZoneColor&&b(),this.makeImage()}var d=Math.round,e=this._oContext,f=this._htOption;f.title||f.subTitle||(f.height-=f.titleHeight,f.titleHeight=0);var g=a.getModuleCount(),h=d(f.width/g),i=d((f.height-f.titleHeight)/g);f.quietZone=d(f.quietZone),this._htOption.width=h*g,this._htOption.height=i*g+f.titleHeight,this._canvas.width=this._htOption.width+2*this._htOption.quietZone,this._canvas.height=this._htOption.height+2*this._htOption.quietZone;var j="rgba(0, 0, 0, .6)",k="rgba(255, 255, 255, .7)",l="rgba(0,0,0,0)";"JPG"==f.format&&("transparent"==f.quietZoneColor&&(f.quietZoneColor="#ffffff"),f.logoBackgroundTransparent=!1,j=f.colorDark,k=f.colorLight,l=f.colorLight,e.fillStyle="#ffffff",e.fillRect(0,0,this._canvas.width,this._canvas.height));var m=this;if(f.backgroundImage){var n=new Image;n.onload=function(){e.globalAlpha=1,e.globalAlpha=f.backgroundImageAlpha,e.drawImage(n,0,f.titleHeight,f.width+2*f.quietZone,f.height+2*f.quietZone-f.titleHeight),e.globalAlpha=1,c.call(m,a)},n.src=f.backgroundImage}else c.call(m,a)},Drawing.prototype.makeImage=function(){var a=this.makeOptions,b=this;if("FILE"==a.makeType){this._htOption.onRenderingStart&&this._htOption.onRenderingStart(this._htOption);var c=fs.createWriteStream(a.path),d=void 0;d="PNG"==this._htOption.format?this._canvas.createPNGStream({compressionLevel:this._htOption.compressionLevel}):this._canvas.createJPEGStream({quality:this._htOption.quality}),d.pipe(c),c.on("finish",()=>{b.resolve({})})}else"URL"==a.makeType&&(this._htOption.onRenderingStart&&this._htOption.onRenderingStart(this._htOption),"PNG"==this._htOption.format?this._canvas.toDataURL((a,c)=>{b.resolve(c)}):this._canvas.toDataURL("image/jpeg",(a,c)=>{b.resolve(c)}))},Drawing.prototype.isPainted=function(){return this._bIsPainted},Drawing.prototype.round=function(a){return a?Math.floor(1e3*a)/1e3:a};function QRCode(a){if(this._htOption={width:256,height:256,typeNumber:4,colorDark:"#000000",colorLight:"#ffffff",correctLevel:QRErrorCorrectLevel.H,dotScale:1,quietZone:0,quietZoneColor:"transparent",title:"",titleFont:"bold 16px Arial",titleColor:"#000000",titleBackgroundColor:"#ffffff",titleHeight:0,titleTop:30,subTitle:"",subTitleFont:"14px Arial",subTitleColor:"#4F4F4F",subTitleTop:60,logo:void 0,logoWidth:void 0,logoHeight:void 0,logoBackgroundColor:"#ffffff",logoBackgroundTransparent:!1,PO:void 0,PI:void 0,PO_TL:void 0,PI_TL:void 0,PO_TR:void 0,PI_TR:void 0,PO_BL:void 0,PI_BL:void 0,AO:void 0,AI:void 0,timing:void 0,timing_H:void 0,timing_V:void 0,backgroundImage:void 0,backgroundImageAlpha:1,autoColor:!1,onRenderingStart:void 0,format:"PNG",compressionLevel:6,quality:.75,version:0},"string"==typeof a&&(a={text:a}),a)for(var b in a)this._htOption[b]=a[b];(0>this._htOption.version||40<this._htOption.version)&&(console.warn("QR Code version '"+this._htOption.version+"' is invalidate, reset to 0"),this._htOption.version=0),this._htOption.format=this._htOption.format.toUpperCase(),"PNG"!=this._htOption.format&&"JPG"!=this._htOption.format&&(console.warn("Image format '"+this._htOption.format+"' is invalidate, reset to 'PNG'"),this._htOption.format="PNG"),"PNG"==this._htOption.format&&(0>this._htOption.compressionLevel||9<this._htOption.compressionLevel)?(console.warn(this._htOption.compressionLevel+" is invalidate, PNG compressionLevel must between 0 and 9, now reset to 6. "),this._htOption.compressionLevel=1):(0>this._htOption.quality||1<this._htOption.quality)&&(console.warn(this._htOption.quality+" is invalidate, JPG quality must between 0 and 1, now reset to 0.75. "),this._htOption.quality=.75),(0>this._htOption.dotScale||1<this._htOption.dotScale)&&(console.warn(this._htOption.dotScale+" , is invalidate, dotScale must greater than 0, less than or equal to 1, now reset to 1. "),this._htOption.dotScale=1),(0>this._htOption.backgroundImageAlpha||1<this._htOption.backgroundImageAlpha)&&(console.warn(this._htOption.backgroundImageAlpha+" , is invalidate, backgroundImageAlpha must between 0 and 1, now reset to 1. "),this._htOption.backgroundImageAlpha=1),this._htOption.height+=this._htOption.titleHeight,this._oQRCode=null,this._oQRCode=new QRCodeModel(_getTypeNumber(this._htOption.text,this._htOption),this._htOption.correctLevel),this._oQRCode.addData(this._htOption.text),this._oQRCode.make()}QRCode.prototype.saveImage=function(a){a=Object.assign({makeType:"FILE",path:null},a);var b=new Drawing(this._htOption);b.makeOptions=a;try{var c=this;return new Promise(a=>{b.resolve=a,b.draw(c._oQRCode)})}catch(a){console.error(a)}},QRCode.prototype.toDataURL=function(){var a=new Drawing(this._htOption);a.makeOptions={makeType:"URL"};try{var b=this;return new Promise(c=>{a.resolve=c,a.draw(b._oQRCode)})}catch(a){console.error(a)}},QRCode.CorrectLevel=QRErrorCorrectLevel,module.exports=QRCode;